<?php if (Tools::getAction() == 'create'): ?>
    <h5 class="mb-3 pb-1">
        Create a new CMS collection
    </h5>
    <?php
        
    if (!empty($_POST['collection']['title']) && (!empty($_POST['collection']['product_keywords']) || !empty($_POST['collection']['cms_query']))) {
        $VDEVShopifyCollection = $VDEVShopify->apiClass('collection');
        
        $collectionObj = $VDEVShopifyCollection;
        
        $collectionTitle = $_POST['collection']['title'];
        
        /* Collection handle */
        $collectionHandle = trim($collectionTitle);
        $collectionHandle = mb_strtolower($collectionHandle, 'utf-8');
        $collectionHandle = preg_replace('/[^\-0-9a-z]+/', '-', $collectionHandle);
        // $collectionHandle .= '-cms';
        $collectionHandle .= '-shop';
        /* /Collection handle */
        
        /* Creating a collection */
        $collection = $collectionObj->createCollection([
            'title' => $collectionTitle,
            'handle' => $collectionHandle,
            'template_suffix' => 'cms'
        ], true);
        /* /Creating a collection */
        
        if (empty($collection['id'])) {
            $error = $collectionObj->getLastCallError();
            ?>
            <div class="alert alert-danger" role="alert">
                <b>Error:</b> <?= $error ?>
            </div>
            <?php
            
        } else if (!empty($collection['id'])) {

            /* CMS: query */
            if (!empty($_POST['collection']['cms_query'])) {
            
                $VDEVShopifyCollection->updateCollectionMetafield([
                        'id' => (int)$collection['id']
                    ], [
                        'namespace' => 'cms',
                        'key' => 'query',
                        'value' => trim($_POST['collection']['cms_query'])
                    ]
                );
            
            } else if (!empty($_POST['collection']['product_keywords'])) {
            
                $VDEVShopifyCollection->updateCollectionMetafield([
                        'id' => (int)$collection['id']
                    ], [
                        'namespace' => 'cms',
                        'key' => 'query',
                        'value' => Tools::getShopCmsQuery(trim($_POST['collection']['product_keywords']), 'search', Tools::getShop())
                    ]
                );
            }
            /* /CMS: query */
            
            /* Footer: title */
            if (!empty($_POST['collection']['footer_title'])) {
            
                // if (Tools::getShop() == 'wmr-shoehq.myshopify.com') {
                    // $VDEVShopifyCollection->updateCollectionMetafield([
                    //         'id' => (int)$collection['id']
                    //     ], [
                    //         'namespace' => 'shogun',
                    //         'key' => 'below',
                    //         'value' => trim($_POST['collection']['footer_text'])
                    //     ]
                    // );
                    
                // } else {
                    $VDEVShopifyCollection->updateCollectionMetafield([
                            'id' => (int)$collection['id']
                        ], [
                            'namespace' => 'footer',
                            'key' => 'title',
                            'value' => trim($_POST['collection']['footer_title'])
                        ]
                    );
                // }
            }
            /* /Footer: title */
            
            /* Footer: text */
            if (!empty($_POST['collection']['footer_text'])) {
            
                // if (Tools::getShop() == 'wmr-shoehq.myshopify.com') {
                //     $VDEVShopifyCollection->updateCollectionMetafield([
                //             'id' => (int)$collection['id']
                //         ], [
                //             'namespace' => 'shogun',
                //             'key' => 'below',
                //             'value' => trim($_POST['collection']['footer_text'])
                //         ]
                //     );
                    
                // } else {
                    $VDEVShopifyCollection->updateCollectionMetafield([
                            'id' => (int)$collection['id']
                        ], [
                            'namespace' => 'footer',
                            'key' => 'text',
                            'value' => trim($_POST['collection']['footer_text'])
                        ]
                    );
                // }
            }
            /* /Footer: text */
            
            /* Footer: links */
            if (!empty($_POST['collection']['footer_links_collection_id'])) {
                $footerLinksCollection = $VDEVShopifyCollection->getCollectionById((int)$_POST['collection']['footer_links_collection_id']);
                
                if (!empty($footerLinksCollection['id'])) {
                    echo '<div class="alert alert-success" role="alert">Footer links were updated</div>';
                    
                    $footerLinksCollectionMetafield = $VDEVShopifyCollection->getCollectionMetafields($footerLinksCollection, 'footer', 'links');
                    
                    if (!empty($footerLinksCollectionMetafield)) {
                        $footerLinks = json_decode($footerLinksCollectionMetafield, true);
                    
                    } else {
                        $footerLinks = [];
                    }
                    
                    $footerLinks[] = [
                        'title' => $collection['title'],
                        'url' => '/collections/' . $collection['handle']
                    ];
            
                    $VDEVShopifyCollection->updateCollectionMetafield([
                            'id' => (int)$footerLinksCollection['id']
                        ], [
                            'namespace' => 'footer',
                            'key' => 'links',
                            'value' => json_encode($footerLinks)
                        ]
                    );
                }
            }
            /* /Footer: links */
            ?>
            <div class="alert alert-success" role="alert">
                Collection is created. ID: <?= (int)$collection['id'] ?>
            </div>
            <?php
        }
    }
        
    ?>
    <div class="border-top p-4" style="margin-right: -1.5rem; margin-left: -1.5rem;">
        <!-- Form -->
        <form class="needs-validation" action="<?= Tools::getLink('collection', 'create') ?>" method="POST">
            <div class="row g-3 mb-4">
                
                <div class="col-12">
                  <label class="form-label">Collection title</label>
                  <input type="text" name="collection[title]" class="form-control" placeholder="" value="" required="">
                </div>
                
                <div class="col-5">
                    <label class="form-label">Products keywords</label>
                    <input type="text" name="collection[product_keywords]" class="form-control" placeholder="" value="">
                    <?php if ($accessLevel > 1): ?>
                        <small class="text-muted">ie. gold ring</small>
                    <?php endif; ?>
                </div>
                
                <div class="col-2 text-center">OR</div>
                    
                <div class="col-5">
                    <label class="form-label">CMS query</label>
                    <input type="text" name="collection[cms_query]" class="form-control" placeholder="" value="">
                    <?php if ($accessLevel > 1): ?>
                        <small class="text-muted">ie. <?= htmlspecialchars(Tools::getShopCmsQuery('gold ring', 'search', Tools::getShop())) ?></small>
                    <?php endif; ?>
                </div>
                
                <div class="col-12">
                    <hr>
                </div>
                
                <div class="col-12">
                    <label class="form-label">Footer title</label>
                  <input type="text" name="collection[footer_title]" class="form-control" placeholder="" value="">
                </div>
                
                <div class="col-12">
                    <label class="form-label">Footer text</label>
                    <textarea class="form-control" name="collection[footer_text]" rows="3" placeholder="" value=""></textarea>
                </div>
                
                <div class="col-12">
                    <label class="form-label">Footer links</label>
                    <?php
        
                    $VDEVShopifyCollection = $VDEVShopify->apiClass('collection');
                    $collections = $VDEVShopifyCollection->getAll(['limit' => 10]); // template_suffix = cms
        
                    ?>
                    <select class="form-select" name="collection[footer_links_collection_id]">
                        <option value="">
                            Select a collection
                        </option>
                        <?php foreach ($collections as $collection): ?>
                            <option value="<?= htmlspecialchars($collection['id']) ?>">
                                <?= $collection['title'] ?>
                                <?php
                                
                                $collectionMetafields = $VDEVShopifyCollection->getCollectionMetafields($collection);
                                $collectionFooterLinksMetafield = $VDEVShopifyCollection->getCollectionMetafields($collection, 'footer', 'links');
                                
                                ?>
                            </option>
                        <?php endforeach; ?>
                    </select>
                  <small class="text-muted">It's will assign a new collection to the selected collection</small>
                </div>
            </div>
          
            <button type="submit" class="btn btn-primary" type="submit">
                Create
            </button>
        </form>
        <!-- /Form -->
    </div>
    
<?php elseif (Tools::getAction() == 'edit'): ?>
    <h5 class="mb-3 pb-1">
        Edit the collection
    </h5>
    <?php
    
    $VDEVShopifyCollection = $VDEVShopify->apiClass('collection');
    $collectionId = (int)Tools::getMethod();
    $collection = $VDEVShopifyCollection->getCollectionById((int)$collectionId, false);
    
    if (isset($_POST['collection']['cms_query'])) {
        
        if ($collection['template_suffix'] != 'cms') {
            $VDEVShopifyCollection->updateCollection([
                    'id' => (int)$collection['id']
                ], [
                    'id' => (int)$collectionId,
                    'template_suffix' => 'cms'
                ], true);
        }
        
        /* Metafield: CMS query */
        if (!empty($_POST['collection']['cms_query'])) {
        
            $VDEVShopifyCollection->updateCollectionMetafield([
                    'id' => (int)$collection['id']
                ], [
                    'namespace' => 'cms',
                    'key' => 'query',
                    'value' => trim($_POST['collection']['cms_query'])
                ]
            );
        
        } else if (!empty($_POST['collection']['product_keywords'])) {
        
            $VDEVShopifyCollection->updateCollectionMetafield([
                    'id' => (int)$collection['id']
                ], [
                    'namespace' => 'cms',
                    'key' => 'query',
                    'value' => Tools::getShopCmsQuery(trim($_POST['collection']['product_keywords']), 'search', Tools::getShop())
                ]
            );
        }
        /* /Metafield: CMS query */
        
        ?>
        <div class="alert alert-success" role="alert">
            Collection template is updated. ID: <?= (int)$collectionId ?>
        </div>
        <?php
    }
    
    ?>
    <?php if (!empty($collection)): ?>
        <div class="border-top p-4" style="margin-right: -1.5rem; margin-left: -1.5rem;">
            <!-- Form -->
            <form class="needs-validation" action="<?= Tools::getLink('collection', 'edit', (int)$collectionId) ?>" method="POST">
                <div class="row g-3 mb-4">
                    
                    <div class="col-12">
                      <label class="form-label">Title</label>
                      <input type="text" class="form-control" placeholder="" value="<?= htmlspecialchars($collection['title']) ?>" disabled="disabeld">
                    </div>
                    
                    <div class="col-12">
                      <label class="form-label">Template</label>
                      <input type="text" class="form-control" placeholder="" value="<?= htmlspecialchars($collection['template_suffix']) ?>" disabled="disabeld">
                    </div>
                    
                    <?php $collectionCMSQueryMetafield = $VDEVShopifyCollection->getCollectionMetafields($collection, 'cms', 'query'); ?>
                    <div class="col-12">
                      <label class="form-label">CMS query</label>
                      <input type="text" class="form-control" placeholder="" value="<?= htmlspecialchars($collectionCMSQueryMetafield) ?>" disabled="disabeld">
                    </div>
                    
                    <div class="col-5">
                      <label class="form-label">New products keywords</label>
                      <input type="text" name="collection[product_keywords]" class="form-control" placeholder="" value="">
                    </div>
                    
                    <div class="col-2 text-center">OR</div>
                        
                    <div class="col-5">
                      <label class="form-label">New CMS query</label>
                      <input type="text" name="collection[cms_query]" class="form-control" placeholder="" value="">
                      <small class="text-muted">ie. <?= htmlspecialchars(Tools::getShopCmsQuery('gold ring', 'search', Tools::getShop())) ?></small>
                    </div>
                        
                </div>
              
                <button type="submit" class="btn btn-primary" type="submit" name="submit">
                    Update
                </button>
            </form>
            <!-- /Form -->
        </div>
    <?php endif; ?>
<?php endif; ?>