<h5 class="mb-3 pb-1">
    Footer links
</h5>
<div class="border-top p-4" style="margin-right: -1.5rem; margin-left: -1.5rem;">
    <?php
    
    if (!empty($_GET['products_checked'])) {
        $productsChecked = (int)$_GET['products_checked'];
    
    } else {
        $productsChecked = 0;
    }
    
    $VDEVShopifyProduct = $VDEVShopify->apiClass('product');
    
    $productsParameters = [
        'limit' => 1
    ];
    
    if (!empty($_GET['page_info'])) {
        $productsParameters['page_info'] = $_GET['page_info'];
        
    } else {
        $productsParameters['status'] = 'active';
    }
    
    $products = $VDEVShopifyProduct->getAll($productsParameters, true);
    
    if (empty($products['items'])) {
        exit('<div class="alert alert-warning">Products not found</div>');
    }
    
    ?>
    <?php if (!empty($productsChecked)): ?>
    <div class="alert alert-warning">
        Products updated: <?= (int)$productsChecked ?>
    </div>
    <?php endif; ?>
    <?php
    
    $VDEVShopifyCollection = $VDEVShopify->apiClass('collection');
    $collections = $VDEVShopifyCollection->getAll(['limit' => 200]); // template_suffix = cms
    
    if (empty($collections)) {
        exit('<div class="alert alert-warning">No collections found</div>');
    }
    
    if (Tools::getAction() == 'found_product_without_links') {
        ?>
        <div class="alert alert-success">
            Search for product without links
        </div>
        <?php
        
        foreach ($products['items'] as $i => $cardProduct) {
            
            if ($i >= (int)Tools::getMethod()) {
                ?>
                <div>
                    <b><?= $i ?>:</b> <?= htmlspecialchars($cardProduct['title']) ?>
                </div>
                <?php
                
                $cardProductMetafields = $VDEVShopifyProduct->getMetafieldsById($cardProduct['id'], 'footer', 'links');
                
                if (empty($cardProductMetafields)) {
                    ?>
                    <script>
                        
                        setTimeout(function() {
                            window.location.href = '<?= Tools::getLink('footer_links', 'skip_product', (int)$i) ?>';
                        }, 100);
                        
                    </script>
                    <?php
                }
            }
        }
    }
    
    $database = new Database;
    
    foreach ($products['items'] as $i => $cardProduct) {
        
        if (empty($cardProduct['id'])):
            ?>
            <p class="alert alert-danger">Product ID not found</p>
            <?php
            
            exit;
        endif;
        
        $cardProductCacheForceUpdate = false;
        $cardProductCache = $database->getProductCacheById((int)$cardProduct['id']);
        
        if (empty($cardProductCache)) {
            $newCardProductCache = [
                'shopify_product_id' => (int)$cardProduct['id'],
                'title' => $cardProduct['title'],
                'body_html' => $cardProduct['body_html'],
                'shopify_shop' => Tools::getShop(),
                'metafields' => json_encode([
                    'footer.links' => [
                        'namespace' => 'footer',
                        'key' => 'links',
                        'value' => $VDEVShopifyProduct->getMetafieldsById((int)$cardProduct['id'], 'footer', 'links')
                    ]
                ]),
                'update_date' => date('c')
            ];
            $database->addProductCache($newCardProductCache);
            
            ?>
            <p class="alert alert-success">Product (ID #<?= (int)$cardProduct['id'] ?>): cache is added</p>
            <?php
        
        } else {
            
            if (!empty($cardProductCache['update_date'])) {
                $cardProductUpdateDate = strtotime($cardProductCache['update_date']);
                
                ?>
                <p class="alert alert-info">Product (ID #<?= (int)$cardProduct['id'] ?>): cache is found (set <?= intval((time() - $cardProductUpdateDate) / (60 * 60 * 24)) ?> days ago)(<?= $cardProductCache['update_date'] ?>)</p>
                <?php
                    
                if (
                    time() > (int)$cardProductUpdateDate + 60 * 60 * 24 * 30
                    || 1 == 1
                    ) {
                    $cardProductCacheForceUpdate = true;
                    $newCardProductCache = $cardProductCache;
                    $newCardProductCacheMetafields = json_decode($cardProductCache['metafields'], true);
                    $newCardProductCacheMetafields['metafields']['footer.links'] = [
                        'namespace' => 'footer',
                        'key' => 'links',
                        'value' => $VDEVShopifyProduct->getMetafieldsById((int)$cardProduct['id'], 'footer', 'links')
                    ];
                    $newCardProductCache['metafields'] = json_encode($newCardProductCacheMetafields);
                    $newCardProductCache['update_date'] = date('c');
                    $database->setProductCacheById((int)$cardProduct['id'], $newCardProductCache);
                    
                    ?>
                    <p class="alert alert-success" style="display: none !important;">Product (ID #<?= (int)$cardProduct['id'] ?>): cache is updated</p>
                    <?php
                }
            }
        }
        
        $cardProductCache = $database->getProductCacheById((int)$cardProduct['id']);
        $cardProductCacheMetafields = json_decode($cardProductCache['metafields'], true);
        
        if (empty($cardProductCacheMetafields['footer.links']['value']) || $cardProductCacheForceUpdate) {
            $cmsCollections = [];
            
            if (!empty($collections)) {
                
                foreach ($collections as $i2 => $cardCollection) {
                    
                    if ($cardCollection['template_suffix'] == 'cms') {
                        $cmsCollections[] = $cardCollection;
                    }
                }
                
                if (!empty($cmsCollections)) {
                    shuffle($cmsCollections);
                    $cmsCollections = array_slice($cmsCollections, 0, 6);
                    
                    $cmsCollectionsLinks = [];
                    
                    foreach ($cmsCollections as $cardCmsCollection) {
                        $cmsCollectionsLinks[] = [
                            'title' => $cardCmsCollection['title'],
                            'url' => '/collections/' . $cardCmsCollection['handle']
                        ];
                    }
                    
                    switch (Tools::getShop()) {
                        case 'oxford-shop-australia.myshopify.com':
                            /* Glossary (x6) */
                            $cmsCollectionsRandI = rand(0, 5);
                            
                            if (!$cmsCollectionsRandI) {
                                $cmsCollectionsRandLink = [
                                    'title' => 'Glossary',
                                    'url' => '/pages/glossary'
                                ];
                                
                                if (count($cmsCollectionsLinks) == 6) {
                                    $cmsCollectionsLinks[5] = $cmsCollectionsRandLink;
                                    
                                } else {
                                    $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                                }
                            }
                            /* /Glossary (x6) */
                            
                            /* Men's Suits (x10) */
                            // $cmsCollectionsRandI = rand(0, 9);
                            
                            // if (!$cmsCollectionsRandI) {
                            //     $cmsCollectionsRandLink = [
                            //         'title' => 'Men\'s Suits',
                            //         'url' => '/collections/mens-suits'
                            //     ];
                                
                            //     if (count($cmsCollectionsLinks) == 6) {
                            //         $cmsCollectionsLinks[5] = $cmsCollectionsRandLink;
                                    
                            //     } else {
                            //         $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                            //     }
                            // }
                            /* /Men's Suits (x10) */
                            
                            /* Men's Suits (75%) */
                            $cmsCollectionsRandI = rand(0, 99);
                            
                            if ($cmsCollectionsRandI < 75) {
                                $cmsCollectionsRandLink = [
                                    'title' => 'Men\'s Suits',
                                    'url' => '/collections/mens-suits'
                                ];
                                
                                if (count($cmsCollectionsLinks) == 6) {
                                    $cmsCollectionsLinks[5] = $cmsCollectionsRandLink;
                                    
                                } else {
                                    $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                                }
                            }
                            /* /Men's Suits (75%) */
                            break;
                            
                        case 'wmr-shoehq.myshopify.com':
                            
                            // if (1 == 2) {
                            //     /* Sandals (x6) */
                            //     $cmsCollectionsRandI = rand(0, 5);
                                
                            //     if (!$cmsCollectionsRandI) {
                            //         $cmsCollectionsRandLink = [
                            //             'title' => 'Sandals',
                            //             'url' => '/collections/sandals'
                            //         ];
                                    
                            //         if (count($cmsCollectionsLinks) == 6) {
                            //             $cmsCollectionsLinks[5] = $cmsCollectionsRandLink;
                                        
                            //         } else {
                            //             $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                            //         }
                            //     }
                            //     /* /Sandals (x6) */
                                
                            //     /* Heels (x10) */
                            //     $cmsCollectionsRandI = rand(0, 9);
                                
                            //     if (!$cmsCollectionsRandI) {
                            //         $cmsCollectionsRandLink = [
                            //             'title' => 'Heels',
                            //             'url' => '/collections/heels'
                            //         ];
                                    
                            //         if (count($cmsCollectionsLinks) == 6) {
                            //             $cmsCollectionsLinks[5] = $cmsCollectionsRandLink;
                                        
                            //         } else {
                            //             $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                            //         }
                            //     }
                            //     /* /Heels (x10) */
                            // }
                            
                            /* Sandals (100%) */
                            $cmsCollectionsRandLink = [
                                'title' => 'Sandals',
                                'url' => '/collections/sandals'
                            ];
                            
                            if (count($cmsCollectionsLinks) == 6) {
                                $cmsCollectionsLinks[5] = $cmsCollectionsRandLink;
                                
                            } else {
                                $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                            }
                            /* /Sandals (100%) */
                                
                            /* Ankle Boots (40%) */
                            $cmsCollectionsRandI = rand(1, 100);
                                
                            if ($cmsCollectionsRandI <= 40) {
                                $cmsCollectionsRandLink = [
                                    'title' => 'Ankle Boots',
                                    'url' => '/collections/ankle-boots-shop'
                                ];
                                
                                if (count($cmsCollectionsLinks) == 6) {
                                    $cmsCollectionsLinks[4] = $cmsCollectionsRandLink;
                                    
                                } else {
                                    $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                                }
                            }
                            /* /Ankle Boots (40%) */
                              
                            /* Loafers (50%) */
                            $cmsCollectionsRandI = rand(0, 1);
                                
                            if (!$cmsCollectionsRandI) {
                                $cmsCollectionsRandLink = [
                                    'title' => 'Loafers',
                                    'url' => '/collections/loafers'
                                ];
                                
                                if (count($cmsCollectionsLinks) == 6) {
                                    $cmsCollectionsLinks[4] = $cmsCollectionsRandLink;
                                    
                                } else {
                                    $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                                }
                            }
                            /* /Loafers (50%) */
                              
                            /* Heels (20%) */
                            $cmsCollectionsRandI = rand(0, 4);
                                
                            if (!$cmsCollectionsRandI) {
                                $cmsCollectionsRandLink = [
                                    'title' => 'Heels',
                                    'url' => '/collections/heels'
                                ];
                                
                                if (count($cmsCollectionsLinks) == 6) {
                                    $cmsCollectionsLinks[3] = $cmsCollectionsRandLink;
                                    
                                } else {
                                    $cmsCollectionsLinks[] = $cmsCollectionsRandLink;
                                }
                            }
                            /* /Heels (20%) */
                                
                            break;
                    }
                    
                    shuffle($cmsCollectionsLinks);
                }
            }
        }
        
        if (!empty($cmsCollectionsLinks) && !empty($productsChecked)) {
            $filePath = __DIR__ . '/../../../public/csv/footer_links.csv';
            
            if (!file_exists($filePath)) {
                exit('File not exist: ' . $filePath);
            }
            
            $file = fopen($filePath, 'a');  /* 'a' for append to file - created if doesn't exit */

            if ($productsChecked == 1) {
                file_put_contents($filePath, '');
                
                $line = [
                    'Product title',
                    'Product URL',
                    'Footer links'
                ];
                fputcsv($file, $line);
            }

            $lineLinks = '';
            
            foreach ($cmsCollectionsLinks as $i2 => $cmsCollectionsLink) {
                
                if ($i2) {
                    $lineLinks .= "\r\n";
                }
                
                $lineLinks .= $cmsCollectionsLink['title'] . "\n" . $cmsCollectionsLink['url'];
            }
            
            $line = [
                $cardProduct['title'],
                '/products/' . $cardProduct['handle'],
                $lineLinks
            ];
            fputcsv($file, $line);
        }
            
        ?>
        <div class="my-3 p-3 bg-body rounded border gap-2">
            <div class="d-flex text-body-secondary pt-1">
                <img src="<?= $cardProduct['image']['src'] ?>"
                     class="bd-placeholder-img flex-shrink-0 me-3 rounded"
                     width="52"
                     height="52"
                     style="object-fit: cover;"
                     alt="">
                <div style="width: 100%;">
                    <p class="pb-3 mb-0 small lh-sm">
                        <strong class="d-block text-gray-dark">
                            <a href="//<?= Tools::getShop() ?>/admin/products/<?= (int)$cardProduct['id'] ?>/"
                               target="_blank">
                                <?= htmlspecialchars($cardProduct['title']) ?>
                            </a>
                        </strong>
                        /products/<?= htmlspecialchars($cardProduct['handle']) ?>
                    </p>
                    <?php
                    
                    switch (Tools::getAction()) {
                        
                        case 'remove_from_all_products':
                            ?>
                            <div class="small mt-3 pb-3">
                                <strong class="d-block text-warning">
                                    New default footer links
                                </strong>
                            </div>
                            <?php
                            
                            $cmsCollectionsLinks = [];
                                    
                            $VDEVShopifyProduct->setMetafieldById((int)$cardProduct['id'],
                                [
                                    'namespace' => 'footer',
                                    'key' => 'links',
                                    'value' => json_encode($cmsCollectionsLinks)
                                ]
                            );
                            
                            /* Updating cache */
                            $newCardProductCache = $cardProductCache;
                            $newCardProductCacheMetafields = json_decode($newCardProductCache['metafields'], true);
                            
                            if (empty($newCardProductCacheMetafields)) {
                                $newCardProductCacheMetafields = [];
                            }
                            
                            $newCardProductCacheMetafields['footer.links'] = [
                                'namespace' => 'footer',
                                'key' => 'links',
                                'value' => json_encode($cmsCollectionsLinks)
                            ];
                            $newCardProductCache['metafields'] = json_encode($newCardProductCacheMetafields);
                            $newCardProductCache['update_date'] = date('c');
                            $database->setProductCacheById((int)$cardProduct['id'], $newCardProductCache);
                            /* /Updating cache */
                            
                            break;
                        
                        case 'add_to_all_products':
                            ?>
                            
                            <?php if (empty($cardProductCacheMetafields['footer.links']['value']) || $cardProductCacheForceUpdate): ?>
                                <div class="small mt-3 pb-3">
                                    <strong class="d-block text-success">
                                        New footer links
                                    </strong>
                                    <?php if (!empty($cmsCollectionsLinks)): ?>
                                        <?php
                                        
                                            $VDEVShopifyProduct->setMetafieldById((int)$cardProduct['id'],
                                                [
                                                    'namespace' => 'footer',
                                                    'key' => 'links',
                                                    'value' => json_encode($cmsCollectionsLinks)
                                                ]
                                            );
                                            
                                            /* Updating cache */
                                            $newCardProductCache = $cardProductCache;
                                            $newCardProductCacheMetafields = json_decode($newCardProductCache['metafields'], true);
                                            
                                            if (empty($newCardProductCacheMetafields)) {
                                                $newCardProductCacheMetafields = [];
                                            }
                                            
                                            $newCardProductCacheMetafields['footer.links'] = [
                                                'namespace' => 'footer',
                                                'key' => 'links',
                                                'value' => json_encode($cmsCollectionsLinks)
                                            ];
                                            $newCardProductCache['metafields'] = json_encode($newCardProductCacheMetafields);
                                            $newCardProductCache['update_date'] = date('c');
                                            $database->setProductCacheById((int)$cardProduct['id'], $newCardProductCache);
                                            /* /Updating cache */
                                            
                                        ?>
                                        <?php foreach ($cmsCollectionsLinks as $cardCmsCollectionsLink): ?>
                                            <small class="d-block mt-2">
                                                <?= htmlspecialchars($cardCmsCollectionsLink['title']) ?>
                                                <span class="d-block" style="opacity: .5;">
                                                    <?= htmlspecialchars($cardCmsCollectionsLink['url']) ?>
                                                </span>
                                            </small>
                                        <?php endforeach; ?>
                                    <?php endif; ?>
                                </div>
                                <?php if (!empty($cmsCollectionsLinks)): ?>
                                    <p class="pt-3 pb-2 mb-0 small lh-sm">
                                        <?= json_encode($cmsCollectionsLinks) ?>
                                    </p>
                                <?php else: ?>
                                    <?php exit('<p>CMS collections not found</p>'); ?>
                                <?php endif; ?>
                            <?php else: ?>
                                <div class="small mt-3 border-bottom pb-3">
                                    <strong class="d-block text-gray" style="color: red;">
                                        Existing footer links
                                    </strong>
                                </div>
                                <p class="pt-3 pb-2 mb-0 small lh-sm">
                                    <?= json_encode($cardProductCacheMetafields['footer.links']['value']) ?>
                                </p>
                                <?php if (Tools::getAction() != 'add_to_all_products'): ?>
                                    <div class="border-top mt-2 pt-3 mb-1">
                                        <a href="<?= Tools::getLink('footer_links', 'skip_product', (int)Tools::getMethod() + 1) ?>"
                                           class="btn btn-warning">
                                            Skip product
                                        </a>
                                        <a href="<?= Tools::getLink('footer_links', 'found_product_without_links', (int)Tools::getMethod() + 1) ?>"
                                           class="btn btn-secondary ms-2"
                                           style="display: none !important;">
                                            Find product without links
                                        </a>
                                    </div>
                                <?php endif; ?>
                            <?php endif; ?>
                            <?php
                            
                            break;
                    }
                    
                    ?>
                    
                    
                    
                    
                </div>
            </div>
        </div>
        <div class="mt-3 pt-3 text-center">
            <?php
            
            switch (Tools::getAction()) {
                
                case 'add_to_all_products':
                    ?>
                    <div style="margin: 0 auto; max-width: 300px;">
                       <div>
                            <button class="btn btn-primary d-block w-100"
                                    disabled>
                                Updating...
                            </button>
                        </div>
                       <div class="mt-2">
                            <a href="<?= Tools::getLink('footer_links') ?>"
                               class="btn btn-warning d-block">
                                Stop
                            </a>
                        </div>
                    </div>
                    <?php
                    
                    if (!empty($products['pagination']['next_page_info'])) {
                        $buttonLink = Tools::getLink('footer_links', Tools::getAction(), (int)Tools::getMethod() + 1);
                        $buttonLink .= '&products_checked=' . ((int)$productsChecked + 1);
                        $buttonLink .= '&page_info=' . $products['pagination']['next_page_info'];
                        ?>
                        <script>
                            
                            setTimeout(function() {
                                window.location.href = '<?= $buttonLink ?>';
                            }, 100);
                            
                        </script>
                        <?php
                    }
                    
                    break;
                    
                case 'remove_from_all_products':
                    ?>
                    <div style="margin: 0 auto; max-width: 300px;">
                       <div>
                            <button class="btn btn-primary d-block w-100"
                                    disabled>
                                Updating...
                            </button>
                        </div>
                       <div class="mt-2">
                            <a href="<?= Tools::getLink('footer_links') ?>"
                               class="btn btn-warning d-block">
                                Stop
                            </a>
                        </div>
                    </div>
                    <?php
                
                    if (!empty($products['pagination']['next_page_info'])) {
                        $buttonLink = Tools::getLink('footer_links', Tools::getAction(), (int)Tools::getMethod() + 1);
                        $buttonLink .= '&products_checked=' . ((int)$productsChecked + 1);
                        $buttonLink .= '&page_info=' . $products['pagination']['next_page_info'];
                        ?>
                        <script>
                            
                            setTimeout(function() {
                                window.location.href = '<?= $buttonLink ?>';
                            }, 100);
                            
                        </script>
                        <?php
                    }
                    
                    break;
                    
                default:
                    ?>
                    <div style="margin: 0 auto; max-width: 300px;">
                        <?php
                        
                        $buttonLink = Tools::getLink('footer_links', 'add_to_all_products', 0);
                        $buttonLink .= '&products_checked=' . ((int)$productsChecked + 1);
                        $buttonLink .= '&page_info=' . $products['pagination']['next_page_info'];
                        
                        ?>
                        <div>
                            <a href="<?= $buttonLink ?>"
                               class="btn btn-primary d-block">
                                Update all
                            </a>
                        </div>
                        <?php
                        
                        $buttonLink = Tools::getLink('footer_links', 'remove_from_all_products', 0);
                        $buttonLink .= '&products_checked=' . ((int)$productsChecked + 1);
                        $buttonLink .= '&page_info=' . $products['pagination']['next_page_info'];
                        
                        ?>
                        <div class="mt-2">
                            <a href="<?= $buttonLink ?>"
                               class="btn btn-danger d-block">
                                Default
                            </a>
                        </div>
                        <div class="mt-4">
                            <a href="/apps/product-list/public/csv/footer_links.csv"
                               class="btn btn-outline-secondary d-block">
                                Download .csv report
                            </a>
                        </div>
                    </div>
                    <?php
                    break;
            }
                    
            ?>
        </div>
        <?php
        
        exit;
    }
    
    ?>
</div>