<h5 class="mb-3 pb-1">
    Redirects
</h5>

<div class="border-top p-4" style="margin-right: -1.5rem; margin-left: -1.5rem;">
    
    <br>
    <h6 class="mb-3 pb-1">
        Product redirects
    </h6>
    <?php
    
    if (!empty($_GET['products_checked'])) {
        $productsChecked = (int)$_GET['products_checked'];
    
    } else {
        $productsChecked = 0;
    }
    
    $VDEVShopifyProduct = $VDEVShopify->apiClass('product');
    $VDEVShopifyRedirect = $VDEVShopify->apiClass('redirect');
    
    $productsParameters = [
        'limit' => 1
    ];
    
    if (isset($_GET['products_checked']) && !empty($_GET['page_info'])) {
        $productsParameters['page_info'] = $_GET['page_info'];
        
    } else {
        // $productsParameters['status'] = 'active';
    }
    
    $products = $VDEVShopifyProduct->getAll($productsParameters, true);
    
    if (empty($products['items'])) {
        exit('<div class="alert alert-warning">Products not found</div>');
    }
    
    foreach ($products['items'] as $i => $cardProduct) {
        
        if (empty($cardProduct['id'])):
            ?>
            <p class="alert alert-danger">Product ID not found</p>
            <?php
            
            exit;
        endif;
    ?>
    
        <div class="my-3 p-3 bg-body rounded border gap-2">
            <div class="d-flex text-body-secondary pt-1">
                <img src="<?= $cardProduct['image']['src'] ?>"
                     class="bd-placeholder-img flex-shrink-0 me-3 rounded"
                     width="52"
                     height="52"
                     style="object-fit: cover;"
                     alt="">
                <div style="width: 100%;">
                    <p class="pb-3 mb-0 small lh-sm">
                        <strong class="d-block text-gray-dark">
                            <a href="//<?= Tools::getShop() ?>/admin/products/<?= (int)$cardProduct['id'] ?>/"
                               target="_blank">
                                <?= htmlspecialchars($cardProduct['title']) ?>
                            </a>
                        </strong>
                        /products/<?= htmlspecialchars($cardProduct['handle']) ?>
                    </p>
                    <?php if (Tools::getAction() == 'add_to_all_products'): ?>
                        <div class="small mt-3 pb-3">
                            <strong class="d-block text-success">
                                Redirects
                            </strong>
                            <small class="d-block mt-2">
                                /en-ca/products/<?= htmlspecialchars($cardProduct['handle']) ?>
                                <span class="d-block" style="opacity: .5;">
                                    https://ca.unepiece.com/products/<?= htmlspecialchars($cardProduct['handle']) ?>                                                
                                </span>
                            </small>
                            <?php 
                            
                            $VDEVShopifyRedirect->add(
                                [
                                    'path' => '/en-ca/products/' . $cardProduct['handle'],
                                    'target' => 'https://ca.unepiece.com/products/' . $cardProduct['handle']
                                ]
                            );
                                 
                            ?>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
        </div>
    <?php 
    
    }
    
    ?>
    
    <div class="mt-3 pt-3 text-center">
        <?php
        
        switch (Tools::getAction()) {
            
            case 'add_to_all_products':
                ?>
                <div style="margin: 0 auto; max-width: 300px;">
                   <?php if (empty($products['pagination']['next_page_info'])): ?>
                       <div>
                            <button class="btn btn-outline-primary d-block w-100"
                                    disabled>
                                Added to all
                            </button>
                        </div>
                   <?php else: ?>
                       <div>
                            <button class="btn btn-primary d-block w-100"
                                    disabled>
                                Updating...
                            </button>
                        </div>
                       <div class="mt-2">
                            <a href="<?= Tools::getLink('footer_links') ?>"
                               class="btn btn-warning d-block">
                                Stop
                            </a>
                        </div>
                        <?php
                        $buttonLink = Tools::getLink('redirects', Tools::getAction(), (int)Tools::getMethod() + 1);
                        $buttonLink .= '&products_checked=' . ((int)$productsChecked + 1);
                        $buttonLink .= '&page_info=' . $products['pagination']['next_page_info'];
                        ?>
                        <script>
                            
                            setTimeout(function() {
                                window.location.href = '<?= $buttonLink ?>';
                            }, 100);
                            
                        </script>
                   <?php endif; ?>
                </div>
                <?php

                break;
                
            default:
                ?>
                <div style="margin: 0 auto; max-width: 300px;">
                    <?php
                    
                    $buttonLink = Tools::getLink('redirects', 'add_to_all_products', 0);
                    
                    ?>
                    <div>
                        <a href="<?= $buttonLink ?>"
                           class="btn btn-primary d-block">
                            Add to all
                        </a>
                    </div>
                </div>
                <?php
                break;
        }
                
        ?>
    </div>
    
    
    <br>
    <h6 class="mb-3 pb-1">
        Collection redirects
    </h6>
    <?php
    
    if (!empty($_GET['collections_checked'])) {
        $collectionsChecked = (int)$_GET['collections_checked'];
    
    } else {
        $collectionsChecked = 0;
    }
    
    $VDEVShopifyCollection = $VDEVShopify->apiClass('collection');
    $VDEVShopifyRedirect = $VDEVShopify->apiClass('redirect');
    
    $collectionsParameters = [
        'limit' => 1
    ];
    
    if (isset($_GET['collections_checked']) && !empty($_GET['page_info'])) {
        $collectionsParameters['page_info'] = $_GET['page_info'];
        
    } else {
        // $collectionsParameters['status'] = 'active';
    }
    
    $collections = $VDEVShopifyCollection->getAll($collectionsParameters, 'custom', true);
    
    if (empty($collections['items'])) {
        exit('<div class="alert alert-warning">Collections not found</div>');
    }
    
    foreach ($collections['items'] as $i => $cardCollection) {
        
        if (empty($cardCollection['id'])):
            ?>
            <p class="alert alert-danger">Collection ID not found</p>
            <?php
            
            exit;
        endif;
    ?>
    
        <div class="my-3 p-3 bg-body rounded border gap-2">
            <div class="d-flex text-body-secondary pt-1">
                <div style="width: 100%;">
                    <p class="pb-3 mb-0 small lh-sm">
                        <strong class="d-block text-gray-dark">
                            <a href="//<?= Tools::getShop() ?>/admin/collections/<?= (int)$cardCollection['id'] ?>/"
                               target="_blank">
                                <?= htmlspecialchars($cardCollection['title']) ?>
                            </a>
                        </strong>
                        /collections/<?= htmlspecialchars($cardCollection['handle']) ?>
                    </p>
                    <?php if (Tools::getAction() == 'add_to_all_collections'): ?>
                        <div class="small mt-3 pb-3">
                            <strong class="d-block text-success">
                                Redirects
                            </strong>
                            <small class="d-block mt-2">
                                /en-ca/collections/<?= htmlspecialchars($cardCollection['handle']) ?>
                                <span class="d-block" style="opacity: .5;">
                                    https://ca.unepiece.com/collections/<?= htmlspecialchars($cardCollection['handle']) ?>                                                
                                </span>
                            </small>
                            <?php 
                            
                            $VDEVShopifyRedirect->add(
                                [
                                    'path' => '/en-ca/collections/' . $cardCollection['handle'],
                                    'target' => 'https://ca.unepiece.com/collections/' . $cardCollection['handle']
                                ]
                            );
                                 
                            ?>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
        </div>
    <?php 
    
    }
    
    ?>
    
    <div class="mt-3 pt-3 text-center">
        <?php
        
        switch (Tools::getAction()) {
            
            case 'add_to_all_collections':
                ?>
                <div style="margin: 0 auto; max-width: 300px;">
                   <?php if (empty($collections['pagination']['next_page_info'])): ?>
                       <div>
                            <button class="btn btn-outline-primary d-block w-100"
                                    disabled>
                                Added to all
                            </button>
                        </div>
                   <?php else: ?>
                       <div>
                            <button class="btn btn-primary d-block w-100"
                                    disabled>
                                Updating...
                            </button>
                        </div>
                       <div class="mt-2">
                            <a href="<?= Tools::getLink('footer_links') ?>"
                               class="btn btn-warning d-block">
                                Stop
                            </a>
                        </div>
                        <?php
                        $buttonLink = Tools::getLink('redirects', Tools::getAction(), (int)Tools::getMethod() + 1);
                        $buttonLink .= '&collections_checked=' . ((int)$collectionsChecked + 1);
                        $buttonLink .= '&page_info=' . $collections['pagination']['next_page_info'];
                        ?>
                        <script>
                            
                            setTimeout(function() {
                                window.location.href = '<?= $buttonLink ?>';
                            }, 100);
                            
                        </script>
                   <?php endif; ?>
                </div>
                <?php

                break;
                
            default:
                ?>
                <div style="margin: 0 auto; max-width: 300px;">
                    <?php
                    
                    $buttonLink = Tools::getLink('redirects', 'add_to_all_collections', 0);
                    
                    ?>
                    <div>
                        <a href="<?= $buttonLink ?>"
                           class="btn btn-primary d-block">
                            Add to all
                        </a>
                    </div>
                </div>
                <?php
                break;
        }
                
        ?>
    </div>
    
    
    <br>
    <h6 class="mb-3 pb-1">
        Page redirects
    </h6>
    <?php
    
    if (!empty($_GET['pages_checked'])) {
        $pagesChecked = (int)$_GET['pages_checked'];
    
    } else {
        $pagesChecked = 0;
    }
    
    $VDEVShopifyPage = $VDEVShopify->apiClass('page');
    $VDEVShopifyRedirect = $VDEVShopify->apiClass('redirect');
    
    $pagesParameters = [
        'limit' => 1
    ];
    
    if (isset($_GET['pages_checked']) && !empty($_GET['page_info'])) {
        $pagesParameters['page_info'] = $_GET['page_info'];
        
    } else {
        // $pagesParameters['status'] = 'active';
    }
    
    $pages = $VDEVShopifyPage->getAll($pagesParameters, true);
    
    if (empty($pages['items'])) {
        exit('<div class="alert alert-warning">Pages not found</div>');
    }
    
    foreach ($pages['items'] as $i => $cardPage) {
        
        if (empty($cardPage['id'])):
            ?>
            <p class="alert alert-danger">Page ID not found</p>
            <?php
            
            exit;
        endif;
    ?>
    
        <div class="my-3 p-3 bg-body rounded border gap-2">
            <div class="d-flex text-body-secondary pt-1">
                <div style="width: 100%;">
                    <p class="pb-3 mb-0 small lh-sm">
                        <strong class="d-block text-gray-dark">
                            <a href="//<?= Tools::getShop() ?>/admin/pages/<?= (int)$cardPage['id'] ?>/"
                               target="_blank">
                                <?= htmlspecialchars($cardPage['title']) ?>
                            </a>
                        </strong>
                        /pages/<?= htmlspecialchars($cardPage['handle']) ?>
                    </p>
                    <?php if (Tools::getAction() == 'add_to_all_pages'): ?>
                        <div class="small mt-3 pb-3">
                            <strong class="d-block text-success">
                                Redirects
                            </strong>
                            <small class="d-block mt-2">
                                /en-ca/collections/<?= htmlspecialchars($cardPage['handle']) ?>
                                <span class="d-block" style="opacity: .5;">
                                    https://ca.unepiece.com/pages/<?= htmlspecialchars($cardPage['handle']) ?>                                                
                                </span>
                            </small>
                            <?php 
                            
                            $VDEVShopifyRedirect->add(
                                [
                                    'path' => '/en-ca/pages/' . $cardPage['handle'],
                                    'target' => 'https://ca.unepiece.com/pages/' . $cardPage['handle']
                                ]
                            );
                                 
                            ?>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
        </div>
    <?php 
    
    }
    
    ?>
    
    <div class="mt-3 pt-3 text-center">
        <?php
        
        switch (Tools::getAction()) {
            
            case 'add_to_all_pages':
                ?>
                <div style="margin: 0 auto; max-width: 300px;">
                   <?php if (empty($pages['pagination']['next_page_info'])): ?>
                       <div>
                            <button class="btn btn-outline-primary d-block w-100"
                                    disabled>
                                Added to all
                            </button>
                        </div>
                   <?php else: ?>
                       <div>
                            <button class="btn btn-primary d-block w-100"
                                    disabled>
                                Updating...
                            </button>
                        </div>
                       <div class="mt-2">
                            <a href="<?= Tools::getLink('footer_links') ?>"
                               class="btn btn-warning d-block">
                                Stop
                            </a>
                        </div>
                        <?php
                        $buttonLink = Tools::getLink('redirects', Tools::getAction(), (int)Tools::getMethod() + 1);
                        $buttonLink .= '&pages_checked=' . ((int)$pagesChecked + 1);
                        $buttonLink .= '&page_info=' . $pages['pagination']['next_page_info'];
                        ?>
                        <script>
                            
                            setTimeout(function() {
                                window.location.href = '<?= $buttonLink ?>';
                            }, 100);
                            
                        </script>
                   <?php endif; ?>
                </div>
                <?php

                break;
                
            default:
                ?>
                <div style="margin: 0 auto; max-width: 300px;">
                    <?php
                    
                    $buttonLink = Tools::getLink('redirects', 'add_to_all_pages', 0);
                    
                    ?>
                    <div>
                        <a href="<?= $buttonLink ?>"
                           class="btn btn-primary d-block">
                            Add to all
                        </a>
                    </div>
                </div>
                <?php
                break;
        }
                
        ?>
    </div>
    
    <br>
    <br>
    <h6 class="mb-3 pb-1">
        Recent redirects
    </h6>
    <?php
    
    $VDEVShopifyRedirect = $VDEVShopify->apiClass('redirect');
    $redirectsParameters = [
        'limit' => 50
    ];
    
    if (!empty($_GET['page_info'])) {
        $redirectsParameters['page_info'] = htmlspecialchars($_GET['page_info']);
    }
    
    $redirects = $VDEVShopifyRedirect->getAll($redirectsParameters, true);
    
    ?>
    <?php if (!empty($redirects['items'])): ?>
        <div class="list-group list-group-flush border-top border-bottom scrollarea" style="margin-right: -1.5rem; margin-left: -1.5rem;">
            <?php foreach ($redirects['items'] as $i => $redirect): ?>
                <?php if (!empty($redirect['path']) && !empty($redirect['target'])): ?>
                    <div class="list-group-item list-group-item-action py-3 px-4 lh-sm">
                        <div class="d-flex w-100 align-items-center justify-content-between" style="opacity: .5">
                            <strong class="mb-1">
                                <?= htmlspecialchars($redirect['path']) ?>
                            </strong>
                            <small class="text-trim">
                                <?= htmlspecialchars($redirect['id']) ?>
                            </small>
                        </div>
                        <div class="col-10 pb-1 small">
                            <?= htmlspecialchars($redirect['target']) ?>
                        </div>
                    </div>
                <?php endif; ?>
            <?php endforeach; ?>
        </div>
        <?php if (1 == 2): ?>
        <?php if (!empty($redirects['pagination']['prev_page_info']) || !empty($redirects['pagination']['next_page_info'])): ?>
            <div class="text-center p-4">
                <?php if (!empty($redirects['pagination']['prev_page_info'])): ?>
                    <a href="<?= Tools::getLink('redirects') ?>&page_info=<?= htmlspecialchars($redirects['pagination']['prev_page_info']) ?>"
                       class="btn btn-outline-primary">
                        Prev
                    </a>
                <?php endif; ?>
                <?php if (!empty($redirects['pagination']['next_page_info'])): ?>
                    <a href="<?= Tools::getLink('redirects') ?>&page_info=<?= htmlspecialchars($redirects['pagination']['next_page_info']) ?>"
                       class="btn btn-primary">
                        Next
                    </a>
                <?php endif; ?>
            </div>
        <?php endif; ?>
        <?php endif; ?>
    <?php endif; ?>
</div>